
//void comm32(unsigned char a);
//void write32(unsigned char a);
//void data32(unsigned const char *adr, unsigned int count);


void comm32(unsigned char a)
{  
DDRC |= 0xFF;
PORTD |= 0x40; 		//A0=1

PORTC = a;

PORTD &= ~0x80;		//CS=0
PORTD &= ~0x20;		//WR=0
asm("nop");
//#asm("nop")
//#asm("nop")
PORTD |= 0x20;		//WR=1
PORTD |= 0x80;		//CS=1
DDRC &= ~0x00;
}    

void write32(unsigned char a)
{
DDRC |= 0xFF;
PORTD &= ~0x40; 		//A0=0
//a= ~a;
PORTC = a;

PORTD &= ~0x80;		//CS=0
PORTD &= ~0x20;		//WR=0
asm("nop");
//#asm("nop")
//#asm("nop")
PORTD |= 0x20;		//WR=1
PORTD |= 0x80;		//CS=1
DDRC &= ~0x00;
}


void data32(const unsigned char __flash *adr, unsigned int count)
{
while(count-- != 0)
	{
	write32(*adr);
        adr++;
	}
}

void LCD_PUTC(unsigned char ch,unsigned char inv)
{
    unsigned int textL;
    unsigned char i;   
    //      ,   
    //   
    //if(ch<0x90) textL = (ch-0x20)<<3;
    //else textL = (ch-0x60)<<3;
    textL = (ch-0x20)<<3;
    
    for(i=0; i<8; i++)
        {
        //write32(font1[ch-0x20]);
        //write32(font1[0x08+i]);
        if(inv == 0) write32(font1[textL+i]);
        else write32(~font1[textL+i]);
        } 
}   


void LCD_PUTSF(unsigned char e, unsigned char x, unsigned int y, const unsigned char str[],unsigned char inv)
{
unsigned char i=0;
unsigned int adr;

adr = e;
adr = adr * 9600;

if(y == 0)adr = adr + x;
else 
    {
    y = y * 40;
    adr = adr + x;
    adr = adr + y;
    }
//     
comm32(0x4F);		//CSRDIR (0x4C-, 0x4D-, 0x4E-, 0x4F-)

while(str[i])
    {
    //comm32(0x4F);		//CSRDIR (0x4C-, 0x4D-, 0x4E-, 0x4F-)
    comm32(0x46);		//CSRW  
    write32(adr);              //
    write32(adr >> 8);              //
    comm32(0x42);		//MWRITE   
    LCD_PUTC(str[i],inv);
    adr++;
    i++; 
    }  
}

void LCD_PUTS(unsigned char e, unsigned char x, unsigned int y, char str[],unsigned char inv)
{
unsigned char i=0;
unsigned int adr;

adr = e;
adr = adr * 9600;

if(y == 0)adr = adr + x;
else 
    {
    y = y * 40;
    adr = adr + x;
    adr = adr + y;
    }
//     
comm32(0x4F);		//CSRDIR (0x4C-, 0x4D-, 0x4E-, 0x4F-)

while(str[i])
    {
    //comm32(0x4F);		//CSRDIR (0x4C-, 0x4D-, 0x4E-, 0x4F-)
    comm32(0x46);		//CSRW  
    write32(adr);              //
    write32(adr >> 8);              //
    comm32(0x42);		//MWRITE   
    LCD_PUTC(str[i],inv);
    adr++;
    i++; 
    }  
}

void fill(void)
{
unsigned int temp;
unsigned int temp1;
char count=0;
char count1=0;
char count2=0;

while(count1 < 5)
	{
	temp = count_fill;
	temp >>= 8;
	temp1 = count_fill;
        
	comm32(0x4F);		//CSRDIR_doun
	
	comm32(0x46);		//CSRW
	write32(temp1);
	write32(temp);
	comm32(0x42);		//MWRITE
	
	count = 0;
	while(count < 19)
		{
		write32(bmp3[count2++]);
		count++;
		}
	count_fill++;
	count1++;
	}
//count_fill = count_fill - 5;
}

void cls_fill(void)
{
unsigned int temp;
unsigned int temp1;
char count=0;
char count1=0;
unsigned int count2=28040;

while(count1 < 10)
	{
	temp = count2;
	temp >>= 8;
	temp1 = count2;
        
	comm32(0x4F);		//CSRDIR_doun
	
	comm32(0x46);		//CSRW
	write32(temp1);
	write32(temp);
	comm32(0x42);		//MWRITE
	
	count = 0;
	while(count < 19)
		{
		write32(0);
		count++;
		}
	count2++;
	count1++;
	}
//count_fill = count_fill - 5;
}

void clrgraph(void)
{
int count=0;

while(count < 9600)
	{
	write32(0x00);
//	delay_ms(5);
	count++;
	}
}

void lcd_init_1p(void)
{
//SYSTEM SET
comm32(0x40);   //reset, off, disable standbuy		
write32(0x30);
write32(0x87);
write32(0x00);//07);
write32(0x27);  //...+1*8=320
write32(0x30);//
write32(0xEF);
write32(0x28);
write32(0x00);

comm32(0x44);		//SCROLL
write32(0x00);
write32(0x00);
write32(0xF0);//EF
write32(0x80);
write32(0x25);
write32(0xF0);//EF
write32(0x00);
write32(0x4B);
//write32(0x00);
//write32(0x00);

comm32(0x5D);		//CSRFORM
write32(0x07);
write32(0x87);

comm32(0x4C);		//CSRDIR

comm32(0x5A);		//HDOT SCR
write32(0x00);

comm32(0x5B);		//OVLAY
write32(0x1F);

comm32(0x59);		//DISP ON/OFF
write32(0xD4);//54);//D4);

comm32(0x46);		//CSRW
write32(0x00);
write32(0x00);

comm32(0x42);		//MWRITE
clrgraph();

comm32(0x46);		//CSRW
write32(0x80);
write32(0x25);

comm32(0x42);		//MWRITE
clrgraph();

comm32(0x46);		//CSRW
write32(0x00);
write32(0x4B);

comm32(0x42);		//MWRITE
clrgraph();
}


void lcd_init_2p(void)
{
//SYSTEM SET
comm32(0x40);   //reset, off, disable standbuy		
write32(0x30);
write32(0x87);
write32(0x00);//07);
write32(0x27);
write32(0x30);//2B);//42);//39);
write32(0xEF);
write32(0x28);
write32(0x00);

comm32(0x44);		//SCROLL
write32(0x00);
write32(0x00);
write32(0xF0);//EF
write32(0x80);
write32(0x25);
write32(0xF0);//EF
write32(0x00);
write32(0x4B);
//write32(0x00);
//write32(0x00);

comm32(0x5D);		//CSRFORM
write32(0x07);
write32(0x87);

comm32(0x4C);		//CSRDIR

comm32(0x5A);		//HDOT SCR
write32(0x00);

comm32(0x5B);		//OVLAY
write32(0x1F);         // C-or, D-exclusive or, E-and, F-prioritized or

comm32(0x59);		//DISP ON/OFF
write32(0xD4);//54);//D4);

comm32(0x46);		//CSRW
write32(0x00);
write32(0x00);

comm32(0x42);		//MWRITE
clrgraph();

comm32(0x46);		//CSRW
write32(0x80);
write32(0x25);

comm32(0x42);		//MWRITE
clrgraph();

comm32(0x46);		//CSRW
write32(0x00);
write32(0x4B);

comm32(0x42);		//MWRITE
clrgraph();
}



void print_mode(unsigned char adr, const unsigned char __flash *bmp)
{
//char count=0;
char count1=0;
//char count2=0;

unsigned int adr_hl;
unsigned int adr_h;
unsigned int adr_l;

switch(adr)
	{
	case 0:
		comm32(0x4C);		//CSRDIR_rait
		adr_hl = 0x0026;
		while(count1 < 8)
			{
			adr_h = adr_hl;
			adr_h >>= 8;
			adr_l = adr_hl;
			comm32(0x46);		//CSRW
			write32(adr_l);
			write32(adr_h);
			comm32(0x42);		//MWRITE

			write32(*bmp++);//[count++]);
			write32(*bmp++);//[count++]);

			count1++;
			adr_hl = adr_hl + 40;
			}
		break;
	case 1: 
		comm32(0x4C);		//CSRDIR_rait
		adr_hl = 8924;//0x485B;
		while(count1 < 8)
			{
			adr_h = adr_hl;
			adr_h >>= 8;
			adr_l = adr_hl;
			comm32(0x46);		//CSRW
			write32(adr_l);
			write32(adr_h);
			comm32(0x42);		//MWRITE

			write32(*bmp++);//[count++]);
			write32(*bmp++);//[count++]);

			count1++;
			adr_hl = adr_hl + 40;
			}
		break;
	case 2:
		comm32(0x4C);		//CSRDIR_rait
		adr_hl = 8931;//0x4860;
		while(count1 < 8)
			{
			adr_h = adr_hl;
			adr_h >>= 8;
			adr_l = adr_hl;
			comm32(0x46);		//CSRW
			write32(adr_l);
			write32(adr_h);
			comm32(0x42);		//MWRITE

			write32(*bmp++);//[count++]);
			write32(*bmp++);//[count++]);

			count1++;
			adr_hl = adr_hl + 40;
			}
		break;
	case 5:
		comm32(0x4C);		//CSRDIR_rait
		adr_hl = 9271;//8943;//0x486F;
		while(count1 < 8)
			{
			adr_h = adr_hl;
			adr_h >>= 8;
			adr_l = adr_hl;
			comm32(0x46);		//CSRW
			write32(adr_l);
			write32(adr_h);
			comm32(0x42);		//MWRITE

			write32(*bmp++);//[count++]);
			write32(*bmp++);//[count++]);

			count1++;
			adr_hl = adr_hl + 40;
			}
        	break;
        }
}


void print_stop(const unsigned __flash char *_bmp)
{
char count=0;
char count1=0;
unsigned int adr_hl;
unsigned int adr_h;
unsigned int adr_l;

comm32(0x4C);		//CSRDIR_rait
adr_hl = 0x0022;
while(count1 < 9)
	{
	adr_h = adr_hl;
	adr_h >>= 8;
	adr_l = adr_hl;
	comm32(0x46);		//CSRW
	write32(adr_l);
	write32(adr_h);
	comm32(0x42);		//MWRITE
	write32(_bmp[count++]);
	write32(_bmp[count++]);
	write32(_bmp[count++]);

	count1++;
	adr_hl = adr_hl + 40;
	}
}

void print_div(unsigned char adr, const unsigned char __flash *_bmp, const unsigned char __flash *_bmp1)
{
char count=0;
char count1=0;
char count2=0;

unsigned int adr_hl;
unsigned int adr_h;
unsigned int adr_l;

switch(adr)
	{
	case 1: 
		comm32(0x4C);		//CSRDIR_rait
		adr_hl = 9240;//0x4998;
		while(count1 < 8)
			{
			adr_h = adr_hl;
			adr_h >>= 8;
			adr_l = adr_hl;
			comm32(0x46);		//CSRW
			write32(adr_l);
			write32(adr_h);
			comm32(0x42);		//MWRITE

			write32(_bmp[count++]);
			write32(_bmp[count++]);
			write32(_bmp[count++]);
			
			write32(_bmp1[count2++]);
			write32(_bmp1[count2++]);
			

			count1++;
			adr_hl = adr_hl + 40;
			}
		break;
	case 2:
		comm32(0x4C);		//CSRDIR_rait
		adr_hl = 9245;//0x499D;
		while(count1 < 8)
			{
			adr_h = adr_hl;
			adr_h >>= 8;
			adr_l = adr_hl;
			comm32(0x46);		//CSRW
			write32(adr_l);
			write32(adr_h);
			comm32(0x42);		//MWRITE

			write32(_bmp[count++]);
			write32(_bmp[count++]);
			write32(_bmp[count++]);
			
			write32(_bmp1[count2++]);
			write32(_bmp1[count2++]);

			count1++;
			adr_hl = adr_hl + 40;
			}
		break;
	case 4:
		comm32(0x4C);		//CSRDIR_rait
		adr_hl = 0x49A7;
		while(count1 < 8)
			{
			adr_h = adr_hl;
			adr_h >>= 8;
			adr_l = adr_hl;
			comm32(0x46);		//CSRW
			write32(adr_l);
			write32(adr_h);
			comm32(0x42);		//MWRITE

			write32(_bmp[count++]);
			write32(_bmp[count++]);
			write32(_bmp[count++]);
			
			write32(_bmp1[count2++]);
			write32(_bmp1[count2++]);

			count1++;
			adr_hl = adr_hl + 40;
			}
		break;
	case 5:
		comm32(0x4C);		//CSRDIR_rait
		adr_hl = 0x49AC;
		while(count1 < 8)
			{
			adr_h = adr_hl;
			adr_h >>= 8;
			adr_l = adr_hl;
			comm32(0x46);		//CSRW
			write32(adr_l);
			write32(adr_h);
			comm32(0x42);		//MWRITE

			write32(_bmp[count++]);
			write32(_bmp[count++]);
			write32(_bmp[count++]);
			
			write32(_bmp1[count2++]);
			write32(_bmp1[count2++]);

			count1++;
			adr_hl = adr_hl + 40;
			}
		break;
	case 6:
		comm32(0x4C);		//CSRDIR_rait
		adr_hl = 0x49B2;
		while(count1 < 8)
			{
			adr_h = adr_hl;
			adr_h >>= 8;
			adr_l = adr_hl;
			comm32(0x46);		//CSRW
			write32(adr_l);
			write32(adr_h);
			comm32(0x42);		//MWRITE

			write32(_bmp[count++]);
			write32(_bmp[count++]);
			write32(_bmp[count++]);
			
			//write32(_bmp1[count2++]);
			//write32(_bmp1[count2++]);

			count1++;
			adr_hl = adr_hl + 40;
			}
		break;
	case 8:
		comm32(0x4C);		//CSRDIR_rait
		adr_hl = 0x49BC;
		while(count1 < 8)
			{
			adr_h = adr_hl;
			adr_h >>= 8;
			adr_l = adr_hl;
			comm32(0x46);		//CSRW
			write32(adr_l);
			write32(adr_h);
			comm32(0x42);		//MWRITE

			write32(_bmp[count++]);
			write32(_bmp[count++]);
			write32(_bmp[count++]);
			
			//write32(_bmp1[count2++]);
			//write32(_bmp1[count2++]);

			count1++;
			adr_hl = adr_hl + 40;
			}
		break;
		
		
		
	case 9:
		comm32(0x4C);		//CSRDIR_rait
		adr_hl = 0x0026;
		while(count1 < 8)
			{
			adr_h = adr_hl;
			adr_h >>= 8;
			adr_l = adr_hl;
			comm32(0x46);		//CSRW
			write32(adr_l);
			write32(adr_h);
			comm32(0x42);		//MWRITE

			write32(_bmp[count++]);
			write32(_bmp[count++]);

			count1++;
			adr_hl = adr_hl + 40;
			}
		break;
	}
}

void print_scroll_time(signed int adr, const unsigned char __flash *_bmp)
{
char count=0;
char count1=0;
//char count2=0;

unsigned int adr_hl;
unsigned int adr_h;
unsigned int adr_l;

comm32(0x4C);		//CSRDIR_rait
adr_hl = 47 + adr;// + 1;	//0x0026;
while(count1 < 7)
	{
	adr_h = adr_hl;
	adr_h >>= 8;
	adr_l = adr_hl;
	comm32(0x46);		//CSRW
	write32(adr_l);
	write32(adr_h);
	comm32(0x42);		//MWRITE
	
	write32(_bmp[count++]);
	write32(_bmp[count++]);
	write32(_bmp[count++]);
	write32(_bmp[count++]);
	write32(_bmp[count++]);
	write32(_bmp[count++]);
	write32(_bmp[count++]);
	write32(_bmp[count++]);
	write32(_bmp[count++]);
	write32(_bmp[count++]);
	write32(_bmp[count++]);
	write32(_bmp[count++]);
	write32(_bmp[count++]);
	write32(_bmp[count++]);
	write32(_bmp[count++]);
	write32(_bmp[count++]);
	write32(_bmp[count++]);
	write32(_bmp[count++]);
	write32(_bmp[count++]);
	write32(_bmp[count++]);
	write32(_bmp[count++]);
	write32(_bmp[count++]);
	
	count1++;
	adr_hl = adr_hl + 40;
	}
}