
//sfrb PORTA=0x1b;
//sfrb DDRA=0x1A;
//sfrb PINA=0x19;
//#define WR_DATA PORTA.0
#define WR_DATA_1 PORTA |= 0x01;
#define WR_DATA_0 PORTA &= ~0x01;
//#define DATA PORTA.1
#define DATA_1 PORTA |= 0x02;
#define DATA_0 PORTA &= ~0x02;
//#define END_RAM PINA.2

//#define OE_ADC_1 PORTA.4
#define OE_ADC_1 PORTA |= 0x10;
#define OE_ADC_0 PORTA &= ~0x10;
//#define DAC_CS PORTA.5
#define DAC_CS_1 PORTA |= 0x20;
#define DAC_CS_0 PORTA &= ~0x20;
//#define DAC_CLK PORTA.6
#define DAC_CLK_1 PORTA |= 0x40;
#define DAC_CLK_0 PORTA &= ~0x40;
//#define DAC_DATA PORTA.7
#define DAC_DATA_1 PORTA |= 0x80;
#define DAC_DATA_0 PORTA &= ~0x80;

//sfrb PORTB=0x18;
//sfrb DDRB=0x17;
//sfrb PINB=0x16;
#define SEL_CLK_RAM_1 PORTB |= 0x01;
#define SEL_CLK_RAM_0 PORTB &= ~0x01;

//#define SEL_CH_1X2 PORTB.2
#define SEL_CH_1X2_1 PORTB |= 0x04;
#define SEL_CH_1X2_0 PORTB &= ~0x04;
//#define RAM_R_S_1 PORTB.3
#define RAM_R_S_1 PORTB |= 0x08
#define RAM_R_S_0 PORTB &= ~0x08
//#define RESET_COUNT_RAM PORTB.4
#define RESET_COUNT_RAM_1 PORTB |= 0x10
#define RESET_COUNT_RAM_0 PORTB &= ~0x10
//#define CLK_RAM_CPU PORTB.5
#define CLK_RAM_CPU_1 PORTB |= 0x20;
#define CLK_RAM_CPU_0 PORTB &= ~0x20;
//#define RESET_COUNT_TRIG PORTB.6        //   
#define RESET_COUNT_TRIG_1 PORTB |= 0x40;
#define RESET_COUNT_TRIG_0 PORTB &= ~0x40;
//#define SELECT_DATA_RAM PORTB.7
#define SELECT_DATA_RAM_1 PORTB |= 0x80;
#define SELECT_DATA_RAM_0 PORTB &= ~0x80;

//sfrb PORTC=0x15;
//sfrb DDRC=0x14;
//sfrb PINC=0x13;

#define DI_LCD DDRC
#define D_LCD PORTC

//sfrb PORTD=0x12;
//sfrb DDRD=0x11;
//sfrb PIND=0x10;

//#define RD_LCD PORTD.4
#define RD_LCD_1 PORTD |= 0x10;
#define RD_LCD_0 PORTD &= ~0x10;
//#define WR_LCD PORTD.5
#define WR_LCD_1 PORTD |= 0x20;
#define WR_LCD_0 PORTD &= ~0x20;
//#define A0_LCD PORTD.6
#define A0_LCD_1 PORTD |= 0x40;
#define A0_LCD_0 PORTD &= ~0x40;
//#define CS_LCD PORTD.7
#define CS_LCD_1 PORTD |= 0x80;
#define CS_LCD_0 PORTD &= ~0x80;

//  SELECT_F2_0   PORTE.2               // "0" 
#define SELECT_F20_1 PORTE |= 0x04
#define SELECT_F20_0 PORTE &= ~0x04
//  SELECT_F2_1   PORTE.3               // "0"
#define SELECT_F21_1 PORTE |= 0x08
#define SELECT_F21_0 PORTE &= ~0x08

#define SELECT_F10_1 PORTE |= 0x10
#define SELECT_F10_0 PORTE &= ~0x10

#define SELECT_F11_1 PORTE |= 0x20
#define SELECT_F11_0 PORTE &= ~0x20

#define TRIG_SEL0_1 PORTE |= 0x40
#define TRIG_SEL0_0 PORTE &= ~0x40

#define TRIG_SEL1_1 PORTE |= 0x80
#define TRIG_SEL1_0 PORTE &= ~0x80


//  RES_LCD       PORTG.2
#define RES_LCD_1 PORTG |= 0x04
#define RES_LCD_0 PORTG &= ~0x04
//  TRIG_FALLING  PORTG.3               //"1" .  , "0" .  
#define TRIG_FALLING_1 PORTG |= 0x08
#define TRIG_FALLING_0 PORTG &= ~0x08
//  RCK_1         PORTG.4
#define RCK_1 PORTG |= 0x10;
#define RCK_0 PORTG &= ~0x10;



//__eeprom unsigned int Edata_reg1 = 0xC0C0;
//__eeprom unsigned char Edata_reg2 = 0x00;
//__eeprom unsigned char Edata_reg3 = 0x22;

__eeprom unsigned char Eselect_div1 = 10;
__eeprom unsigned char Eselect_div2 = 10;
__eeprom unsigned char Eselect_divt = 16;

__eeprom unsigned char Edac_ch1 = 128;
__eeprom unsigned char Edac_ch2 = 128;
__eeprom unsigned char Edac_sinh = 128;

__eeprom unsigned char Epoz_1=128;
__eeprom unsigned char Epoz_2=128;
__eeprom unsigned char Epoz_trig = 128;

__eeprom unsigned char Eillumination = 90;
__eeprom unsigned char Econtrast = 52;

__eeprom unsigned char Emode1 = 0;
__eeprom unsigned char Emode2 = 0;
//char mode3 = 0;
//char mode4 = 0;
__eeprom unsigned char Emode5 = 0;
__eeprom unsigned char Emode6 = 0;
__eeprom unsigned char Emode7 = 0;
__eeprom unsigned char Emode8 = 0;

/*
unsigned char max1=0;
unsigned char min1=0;
unsigned char max2=0;
unsigned char min2=0;
unsigned char max3=0;
unsigned char min3=0;
unsigned char max4=0;
unsigned char min4=0;
unsigned char max5=0;
unsigned char min5=0;
unsigned char max6=0;
unsigned char min6=0;
unsigned char max7=0;
unsigned char min7=0;
unsigned char max8=0;
unsigned char min8=0;
*/

//register 
char da;// @2;
//register 
char Y;// @3;
//register 
char flag_01;// @4;
unsigned char flag_ch;

//unsigned char adc_data;
char sinhr=0;
char tmr0=0;

char key;

//unsigned long int data_reg;
unsigned int data_reg1;// = 0xC0C0;
unsigned char data_reg2;// = 128;
unsigned char data_reg3;// = 0x22;

unsigned char mode1;
unsigned char mode2;
//char mode3 = 0;
//char mode4 = 0;
unsigned char mode5;
unsigned char mode6;
unsigned char mode7;
unsigned char mode8;
//eeprom 
char ring = 0;
//eeprom char stop = 0;
char select_div1=10;
char select_div2=10;
char select_divt=14;
//eeprom 
char select_trig=1;
//eeprom 
char select_edge=1;
int select_scroll_time=7;

//char select_div = 0;

char stop = 0;
unsigned int adc_count=0;
unsigned int count_fill=28040;

//char adc_tab[1220]={0};	//
//char data1[1200]={};
//char data2[1200]={};
char data1[600]={};
char data2[600]={};
char data3[5]={0};

unsigned char dac_ch1;// = 164;
unsigned char dac_ch2;// = 164;
unsigned char dac_sinh;// = 164;
//unsigned char data_clk = 0x00;


unsigned int time = 1;

unsigned char poz_1;
unsigned char poz_2;
//unsigned char poz_trig;

signed char cor_poz_1=0;
signed char cor_poz_2=0;

signed int temp;
unsigned int temp1;
unsigned char temp2;

unsigned char bright;
unsigned char contrast;

unsigned char display = 0;
unsigned char count_menu = 0;

signed int start = 150;

signed int max_ch1;
signed int min_ch1;
signed int max_ch2;
signed int min_ch2;

int bat;