
// Timer interrupt service routine 
#pragma vector = TIMER0_OVF_vect 
__interrupt void TMR0_ovf(void) 
{ 
 char key_old_e;
 
// ADCSR  |= 0x40;
 
 TCNT0 = 0xB9; //reload counter value
 
 DDRD &= ~0x04;
 PORTD &= ~0x04;
 
 DDRB &= ~0x30;
 PORTB |= 0x30;
 DDRC &= ~0xFF;
 DDRC |= 0x01;
 PORTC |= 0x3F;
 PORTC &= ~0x01;
 delay_us(100);
 encoder = (~PIN_Coder & 0x30);  //  PB4,PB5 
if (status_1 != encoder)
        {
        switch (encoder)
                {
                case 0:
                        if (status_1 == 32)
                                {
                                //PORTC.0 = 1;//temp --;
                                //TCCR0 = 0x01;
								//UDR = 20;
                                }
                break;
                case 16:
                        if (status_1 == 48)
                                {
                                //PORTC.1 = 1;//temp ++;
                                //TCCR0 = 0x01;
								UDR = 21;
                                }
                break;
                case 32:
                        if (status_1 == 0)
                                {
                                //PORTC.1 = 1;//temp ++;
                                //TCCR0 = 0x01;
								//UDR = 21;
                                }
                break;
                case 48:
                        if (status_1 == 16)
                                {
                                //PORTC.0 = 1;//temp --;
                                //TCCR0 = 0x01;
								UDR = 20;
                                }
                break;
                }
        status_1 = encoder;
        }
		
 //delay_us(100);
		
 DDRC &= ~0xFF;
 DDRC |= 0x02;
 PORTC |= 0x3F;
 PORTC &= ~0x02;
 delay_us(100);		
 encoder = (~PIN_Coder & 0x30);  //  PB4,PB5
if (status_2 != encoder)
        {
        switch (encoder)
                {
                case 0:
                        if (status_2 == 32)
                                {
                                //PORTC.0 = 1;//temp --;
                                //TCCR0 = 0x01;
								//UDR = 22;
                                }
                break;
                case 16:
                        if (status_2 == 48)
                                {
                                //PORTC.1 = 1;//temp ++;
                                //TCCR0 = 0x01;
								UDR = 23;
                                }
                break;
                case 32:
                        if (status_2 == 0)
                                {
                                //PORTC.1 = 1;//temp ++;
                                //TCCR0 = 0x01;
								//UDR = 23;
                                }
                break;
                case 48:
                        if (status_2 == 16)
                                {
                                //PORTC.0 = 1;//temp --;
                                //TCCR0 = 0x01;
								UDR = 22;
                                }
                break;
                }
        status_2 = encoder;
        }
		
 //delay_us(100);
		
 DDRC &= ~0xFF;
 DDRC |= 0x04;
 PORTC |= 0x3F;
 PORTC &= ~0x04;
 delay_us(100);		
 encoder = (~PIN_Coder & 0x30);  //  PB4,PB5
if (status_3 != encoder)
        {
        switch (encoder)
                {
                case 0:
                        if (status_3 == 32)
                                {
                                //PORTC.0 = 1;//temp --;
                                //TCCR0 = 0x01;
								//UDR = 24;
                                }
                break;
                case 16:
                        if (status_3 == 48)
                                {
                                //PORTC.1 = 1;//temp ++;
                                //TCCR0 = 0x01;
								UDR = 25;
                                }
                break;
                case 32:
                        if (status_3 == 0)
                                {
                                //PORTC.1 = 1;//temp ++;
                                //TCCR0 = 0x01;
								//UDR = 25;
                                }
                break;
                case 48:
                        if (status_3 == 16)
                                {
                                //PORTC.0 = 1;//temp --;
                                //TCCR0 = 0x01;
								UDR = 24;
                                }
                break;
                }
        status_3 = encoder;
        }
		
 //delay_us(100);
		
 DDRC &= ~0xFF;
 DDRC |= 0x08;
 PORTC |= 0x3F;
 PORTC &= ~0x08;
 delay_us(100);	
 encoder = (~PIN_Coder & 0x30);  //  PB4,PB5
if (status_4 != encoder)
        {
        switch (encoder)
                {
                case 0:
                        if (status_4 == 32)
                                {
                                //PORTC.0 = 1;//temp --;
                                //TCCR0 = 0x01;
								//UDR = 26;
                                }
                break;
                case 16:
                        if (status_4 == 48)
                                {
                                //PORTC.1 = 1;//temp ++;
                                //TCCR0 = 0x01;
								UDR = 27;
                                }
                break;
                case 32:
                        if (status_4 == 0)
                                {
                                //PORTC.1 = 1;//temp ++;
                                //TCCR0 = 0x01;
								//UDR = 27;
                                }
                break;
                case 48:
                        if (status_4 == 16)
                                {
                                //PORTC.0 = 1;//temp --;
                                //TCCR0 = 0x01;
								UDR = 26;
                                }
                break;
                }
        status_4 = encoder;
        }
		
 //delay_us(100);
		
 DDRC &= ~0xFF;
 DDRC |= 0x10;
 PORTC |= 0x3F;
 PORTC &= ~0x10;
 delay_us(100);		
 encoder = (~PIN_Coder & 0x30);  //  PB4,PB5
if (status_5 != encoder)
        {
        switch (encoder)
                {
                case 0:
                        if (status_5 == 32)
                                {
                                //PORTC.0 = 1;//temp --;
                                //TCCR0 = 0x01;
								//UDR = 28;
                                }
                break;
                case 16:
                        if (status_5 == 48)
                                {
                                //PORTC.1 = 1;//temp ++;
                                //TCCR0 = 0x01;
								UDR = 29;
                                }
                break;
                case 32:
                        if (status_5 == 0)
                                {
                                //PORTC.1 = 1;//temp ++;
                                //TCCR0 = 0x01;
								//UDR = 29;
                                }
                break;
                case 48:
                        if (status_5 == 16)
                                {
                                //PORTC.0 = 1;//temp --;
                                //TCCR0 = 0x01;
								UDR = 28;
                                }
                break;
                }
        status_5 = encoder;
        }
		
 //delay_us(100);
		
 DDRC &= ~0xFF;
 DDRC |= 0x20;
 PORTC |= 0x3F;
 PORTC &= ~0x20;
 delay_us(100);		
 encoder = (~PIN_Coder & 0x30);  //  PB4,PB5 
if (status_6 != encoder)
        {
        switch (encoder)
                {
                case 0:
                        if (status_6 == 32)
                                {
                                //PORTC.0 = 1;//temp --;
                                //TCCR0 = 0x01;
								//UDR = 30;
                                }
                break;
                case 16:
                        if (status_6 == 48)
                                {
                                //PORTC.1 = 1;//temp ++;
                                //TCCR0 = 0x01;
								UDR = 31;
                                }
                break;
                case 32:
                        if (status_6 == 0)
                                {
                                //PORTC.1 = 1;//temp ++;
                                //TCCR0 = 0x01;
								//UDR = 31;
                                }
                break;
                case 48:
                        if (status_6 == 16)
                                {
                                //PORTC.0 = 1;//temp --;
                                //TCCR0 = 0x01;
								UDR = 30;
                                }
                break;
                }
        status_6 = encoder;
        }
		
key_e = 255;
key_old_e = 255;
count_keyscan_e = 0;
while(count_keyscan_e <= 5)
	{
	DDRC &= ~0x3F;
	PORTC |= 0x3F;
	DDRD |= 0x04;
	PORTD &= ~0x04;
	delay_us(100);
	//UDR = (PINC | 0xC0);
	switch (PINC | 0xC0)
		{
	
		case 0xFE:
			key_e = 32;
			break;
		case 0xFD:
			key_e = 33;
			break;
		case 0xFB:
			key_e = 34;
			break;
		case 0xF7:
			key_e = 35;
			break;
		case 0xDF:
			key_e = 36;
			break;
		case 0xEF:
			key_e = 37;
			break;
		}

	if(key_e == key_old_e)count_keyscan_e++;
	else 
		{
		key_old_e = key_e;
		count_keyscan_e = 0;
		}
	}
	
if(key_e <= 254)
	{
	if((flag_e & 0x01) == 0)	UDR = key_e;
	flag_e |= 0x01;
	delay_us(25000);
	}
else flag_e &= ~0x01;
}



#pragma vector = TIMER1_OVF_vect 
__interrupt void TMR1_ovf(void) 
{
// Place your code here
TCNT1H = 0xC7; //reload counter high value
TCNT1L = 0xC1; //reload counter low value
 
 ADCSR  |= 0x40;
}



#pragma vector = INT1_vect
__interrupt void INT1(void)
{
 //external interupt on INT1
//sleep_disable();
power=2;
count_off = 0;
GICR&=~0x80;
//PORTD |= 0x80;
}

#pragma vector = ADC_vect 
__interrupt void _ADC(void) 
{
  unsigned int a;
  
  a = ADC;
  
  if((flag_adc & 0x01) == 0)
    {
    a = a - 400;
    a = a >> 2;
    if((flag_adc & 0x10) == 0)
        {
        a = a + 50;
        UDR = a;
		if(a <= 67)
			{
			count_off++;
			//if(count_off >= 5)
			//	{
				count_off = 50;
				//power=1;
				//PORTD &= ~0x80;
			//	}
			}
		else
			{
			count_off = 0;
			}
        }
    else
        {
        a = a + 150;
        UDR = a;  
        }
    ADMUX = 0xC6;
    flag_adc |= 0x01;
    }
  else
    {
    if(a >= 200)
      {
      flag_adc |= 0x10;
      }
    else
      {
      flag_adc &= ~0x10;
      }
    ADMUX = 0xC7;
    flag_adc &= ~0x01;
    }

}