/*****************************************************
This program was produced by the
CodeWizardAVR V1.24.2c Standard
Automatic Program Generator
 Copyright 1998-2004 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.ro
e-mail:office@hpinfotech.ro

Project : 
Version : 
Date    : 15.03.2006
Author  : SERGEY                          
Company :                                 
Comments: 


Chip type           : ATmega128
Program type        : Application
Clock frequency     : 16,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 1024
*****************************************************/

#include <mega128.h>
#include <delay.h> 
#include <bmp.c>
#include <font.c>
#include <stdlib.h>

//void comm32(char a);
//void write32(char a);
//#include <key.c>

void print_poz_ch(void);
void print_poz_trig(void);
void print_poz_trig1(void);

#define ADC_VREF_TYPE 0x20

/*
unsigned char max1=0;
unsigned char min1=0;
unsigned char max2=0;
unsigned char min2=0;
unsigned char max3=0;
unsigned char min3=0;
unsigned char max4=0;
unsigned char min4=0;
unsigned char max5=0;
unsigned char min5=0;
unsigned char max6=0;
unsigned char min6=0;
unsigned char max7=0;
unsigned char min7=0;
unsigned char max8=0;
unsigned char min8=0;
*/
register char da @2;
register char Y @3;
register char flag_01 @4;

//unsigned char adc_data;
char sinhr=0;
char tmr0=0;

char key;

unsigned long int data_reg = 0x80000000;

char mode1 = 0;
char mode2 = 0;
char mode3 = 0;
char mode4 = 0;
char mode5 = 0;
//char mode6 = 0;
//char mode7 = 0;
char mode8 = 0;
eeprom char ring = 0;
//eeprom char stop = 0;
char select_div1=10;
char select_div2=10;
char select_divt=14;
eeprom char select_trig=1;
eeprom char select_edge=1;
int select_scroll_time=6;

//char select_div = 0;

char stop = 0;
unsigned int adc_count=0;
unsigned int count_fill=8840;

//char adc_tab[1220]={0};	//
char data1[1220]={0};
char data2[1220]={0};

unsigned char dac_ch1 = 164;
unsigned char dac_ch2 = 164;
unsigned char dac_sinh = 164;
//unsigned char data_clk = 0x00;

unsigned int time = 1;

void data_reg_wr(void)
{
char a = 32;
unsigned long int b = 0;
#asm("cli")

b = data_reg;

PORTA.5 = 0;
PORTA.4 = 0;
while(a != 0)
        {
        if((b & 0x00000001) == 0)PORTA.3 = 0;
        else PORTA.3 = 1;
        #asm("nop")
        #asm("nop")
        PORTA.4 = 1;
        #asm("nop")
        #asm("nop")
        PORTA.4 = 0;
        #asm("nop")
        #asm("nop")
        b >>= 1;
        
        a--;
        }
PORTA.5 = 1;
#asm("nop")
#asm("nop")
PORTA.5 = 0;

#asm("sei")
}





void data_dac_wr(unsigned char ch, unsigned char data_dac)
{
unsigned char a;
unsigned char b;
unsigned char c;
a = 3;
b = ch;
b <<= 1;
c = 5;

while(a != 0)
        {
        if((b & 0x04) == 0)PORTG &= ~0x10;
        else PORTG |= 0x10;
        PORTG &= ~0x08;
        while(c != 0)c--;
        c = 5;
        PORTG |= 0x08;
        while(c != 0)c--;
        c = 5;
        b <<= 1;
        a--;
        }
a = 8;        
b = data_dac;        
while(a != 0)
        {
        if((b & 0x80) == 0)PORTG &= ~0x10;
        else PORTG |= 0x10;
        PORTG &= ~0x08;
        while(c != 0)c--;
        c = 5;
        PORTG |= 0x08;
        while(c != 0)c--;
        c = 5;
        b <<= 1;
        a--;
        }
PORTA.2 = 0;
while(c != 0)c--;
PORTA.2 = 1;

print_poz_ch();
print_poz_trig();
}     




void comm32(char a)
{
DDRC=0xFF;
PORTD.6 = 1; 		//A0=1

PORTC = a;

PORTD.7 = 0;		//CS=0
PORTD.5 = 0;		//WR=0
#asm("nop")
//#asm("nop")
//#asm("nop")
PORTD.5 = 1;		//WR=1
PORTD.7 = 1;		//CS=1
DDRC=0x00;
}    

void write32(char a)
{
DDRC=0xFF;
PORTD.6 = 0; 		//A0=0
//a= ~a;
PORTC = a;

PORTD.7 = 0;		//CS=0
PORTD.5 = 0;		//WR=0
#asm("nop")
//#asm("nop")
//#asm("nop")
PORTD.5 = 1;		//WR=1
PORTD.7 = 1;		//CS=1
DDRC=0x00;
}

void data32(flash char *adr, unsigned int count)
{
unsigned int count1 = 0;

while(count1 < count)
	{
	write32(adr[count1++]);
	}
}



void clrgraph(void)
{
int count=0;

while(count < 9600)
	{
	write32(0x00);
//	delay_ms(5);
	count++;
	}
}

void lcd_init(void)
{
comm32(0x40);		//SYSTEM SET
write32(0x30);
write32(0x87);
write32(0x00);//07);
write32(0x27);
write32(0x30);//2B);//42);//39);
write32(0xEF);
write32(0x28);
write32(0x00);

comm32(0x44);		//SCROLL
write32(0x00);
write32(0x00);
write32(0xF0);//EF
write32(0x80);
write32(0x25);
write32(0xF0);//EF
write32(0x00);
write32(0x4B);
//write32(0x00);
//write32(0x00);

comm32(0x5D);		//CSRFORM
write32(0x07);
write32(0x87);

comm32(0x4C);		//CSRDIR

comm32(0x5A);		//HDOT SCR
write32(0x00);

comm32(0x5B);		//OVLAY
write32(0x1F);

comm32(0x59);		//DISP ON/OFF
write32(0xD4);//54);//D4);

comm32(0x46);		//CSRW
write32(0x00);
write32(0x00);

comm32(0x42);		//MWRITE
clrgraph();

comm32(0x46);		//CSRW
write32(0x80);
write32(0x25);

comm32(0x42);		//MWRITE
clrgraph();

comm32(0x46);		//CSRW
write32(0x00);
write32(0x4B);

comm32(0x42);		//MWRITE
clrgraph();
}

/*
void setgraph(void)
{
int count=0;
//char s;

while(count < 9600)
	{
	write32(bmp0[count++]);
	//delay_ms(5);
	}
}
*/


void massiv(void)
{
unsigned int a=0;
//unsigned char b=0;
char b=0;
char b1=0;
//unsigned char c=0;
char c=0;
char c1=0;
//unsigned char d=0;
char d=0;
char d1=0;
char e=0;
char e1=0;

unsigned int f=555;
unsigned int count=0;
unsigned char count1=0;

if(select_divt == 1)f = 1750;
if(select_divt == 2)f = 1450;
if(select_divt >= 3)f = 555;
while(f != 0)
{
PORTA.1 = 0;
PORTA.1 = 1;
f--;
}
if(select_divt == 1)
{
while(a<1220)//500)
	{
	PORTA.1 = 0;
        PORTA.1 = 1;
        //PORTA.1 = 0;
        PORTG |= 0x03;
        PORTG &= ~0x01;
	b=PINF;
	PORTG |= 0x03;
        PORTG &= ~0x02;
	b1=PINF;
	count++;

	if(a==0)
		{
		d=b;
		e=b;
		goto end_mas1;
		}
	if(b>=d)
		{
		if(b==d)
			{
			d=b;
			e=b;
			goto end_mas1;
			}
		else
			{
			e=d;
			e++;
			d=b;
			goto end_mas1;
			}
		}
	if(b<=e)
		{
		if(b==e)
			{
			d=b;
			e=b;
			goto end_mas1;
			}
		else
			{
			d=e;            	
			d--;
			e=b;
			goto end_mas1;
			}
		}
	d=b;
	e=b;
	end_mas1: 
	
	if(a==0)
		{
		d1=b1;
		e1=b1;
		goto end_mas2;
		}
	if(b1>=d1)
		{
		if(b1==d1)
			{
			d1=b1;
			e1=b1;
			goto end_mas2;
			}
		else
			{
			e1=d1;
			e1++;
			d1=b1;
			goto end_mas2;
			}
		}
	if(b1<=e1)
		{
		if(b1==e1)
			{
			d1=b1;
			e1=b1;
			goto end_mas2;
			}
		else
			{
			d1=e1;            	
			d1--;
			e1=b1;
			goto end_mas2;
			}
		}
	d1=b1;
	e1=b1;
	end_mas2: 
	
	data2[a]=d;
	data1[a]=d1;
	a++;
	data2[a]=e;
	data1[a]=e1;
	a++;	
	}
}
/*
		while(a<500)
			{
			b=adc_tab[count++];
			c=adc_tab[count++];
			if(b>c)
				{
				e=c;
				d=b;
				}
			else 
				{
				d=c;
				e=b;
				}
			data[a++]=d;
			data[a++]=e;	
			}
*/
else
{
while(a<1220)
			{
			PORTA.1 = 0;
                        PORTA.1 = 1;
                        //PORTA.1 = 0;
                        PORTG |= 0x03;
                        PORTG &= ~0x01;
	                b=PINF;
	                PORTG |= 0x03;
                        PORTG &= ~0x02;
	                b1=PINF;
	                count++;
			//b=adc_tab[count++];
			PORTA.1 = 0;
                        PORTA.1 = 1;
                        //PORTA.1 = 0;
	                PORTG |= 0x03;
                        PORTG &= ~0x01;
	                c=PINF;
	                PORTG |= 0x03;
                        PORTG &= ~0x02;
	                c1=PINF;
	                count++;
			//c=adc_tab[count++];
			if(b>c)
				{
				e=c;
				d=b;
				}
			else 
				{
				d=c;
				e=b;
				}
			if(b1>c1)
				{
				e1=c1;
				d1=b1;
				}
			else 
				{
				d1=c1;
				e1=b1;
				}
			count1=0;
			if(select_divt >= 3)
			        {
        		       	while(count1!=3)
	        			{
		           		PORTA.1 = 0;
                                        PORTA.1 = 1;
                                        //PORTA.1 = 0;
        	                        PORTG |= 0x03;
                                        PORTG &= ~0x01;
	                                b=PINF;
	                                PORTG |= 0x03;
                                        PORTG &= ~0x02;
	                                b1=PINF;
	        	       		if(b>d)d=b;
		        		if(b<e)e=b;
		        		if(b1>d1)d1=b1;
		        		if(b1<e1)e1=b1;
			        	count1++;
				        }
			        }
			data2[a]=d;
			data1[a]=d1;
			a++;
			data2[a]=e;
			data1[a]=e1;
			a++;	
			}
}
}

void print_signal(void)
{
unsigned char max1=0;
unsigned char min1=0;
unsigned char max2=0;
unsigned char min2=0;
unsigned char max3=0;
unsigned char min3=0;
unsigned char max4=0;
unsigned char min4=0;
unsigned char max5=0;
unsigned char min5=0;
unsigned char max6=0;
unsigned char min6=0;
unsigned char max7=0;
unsigned char min7=0;
unsigned char max8=0;
unsigned char min8=0;

unsigned char max01=0;
unsigned char min01=0;
unsigned char max02=0;
unsigned char min02=0;
unsigned char max03=0;
unsigned char min03=0;
unsigned char max04=0;
unsigned char min04=0;
unsigned char max05=0;
unsigned char min05=0;
unsigned char max06=0;
unsigned char min06=0;
unsigned char max07=0;
unsigned char min07=0;
unsigned char max08=0;
unsigned char min08=0;

//unsigned char Y=229;
unsigned char X=0;
unsigned int Xs=401;

//unsigned char da=0;
//unsigned char bit_data=0;

unsigned int temp=0;
unsigned int temp1=0;

unsigned int counter;

//unsigned char bx=0;


Y=228;
da=0;

counter = ((select_scroll_time * 50) - 50);

massiv();

//counter=0;
//comm32(0x4C);		//CSRDIR_rait

comm32(0x4F);		//CSRDIR_doun

/*
while(Y >= 28)
	{
	temp = Xs;
	temp >>= 8;
	temp1 = Xs;
	
	//while ((GetStatusLCD()&0x03)!=0x03);  
	//Send8LCD(0, temp1);                     //low byte
	//while ((GetStatusLCD()&0x03)!=0x03);  
	//Send8LCD(0, temp);		       //high byte
	//while ((GetStatusLCD()&0x03)!=0x03);  
	//Send8LCD(1, 0x24);			//set start position
	
	//comm32(0x4C);		//CSRDIR_rait
	comm32(0x46);		//CSRW
	write32(temp1);
	write32(temp);
	comm32(0x42);		//MWRITE
	//data32(bmp1, 9600);

	//while ((GetStatusLCD()&0x03)!=0x03);  
	//Send8LCD(1, 0xB0);			//set autodata mode on
	
	while(X <= 30)
		{
		
		while(bit_data <=7)
			{
			max = data[counter++];
			min = data[counter++];
			//counter++;
			
			if(max >= Y)
				{
				if(min <= Y)
					{
					if(bit_data == 7) da |= 0x01;
					if(bit_data == 6) da |= 0x02;
					if(bit_data == 5) da |= 0x04;
					if(bit_data == 4) da |= 0x08;
					if(bit_data == 3) da |= 0x10;
					if(bit_data == 2) da |= 0x20;
					if(bit_data == 1) da |= 0x40;
					if(bit_data == 0) da |= 0x80;
					}
				}
        	        	
			bit_data++;
			}
        	        	
		//da |= setka_01[Xs++];
		
		//while ((GetStatusLCD()&0x08)!=0x08);  //
		//Send8LCD(0, da);
		write32(da);

		da = 0;
		X++;
		bit_data = 0;
		//counter = counter - 8;
		}
	
	//while ((GetStatusLCD()&0x03)!=0x03);  //
	//Send8LCD(1, 0xB2);			//set autodata mode off
	
	X=0;    	
	Xs=Xs+40;
	Y--;
	counter = 0;
	}
*/
/*
while(X <= 30)//Y >= 28)
	{
	temp = Xs;
	temp >>= 8;
	temp1 = Xs;
	
	//while ((GetStatusLCD()&0x03)!=0x03);  
	//Send8LCD(0, temp1);                     //low byte
	//while ((GetStatusLCD()&0x03)!=0x03);  
	//Send8LCD(0, temp);		       //high byte
	//while ((GetStatusLCD()&0x03)!=0x03);  
	//Send8LCD(1, 0x24);			//set start position
	
	//comm32(0x4C);		//CSRDIR_rait
	comm32(0x46);		//CSRW
	write32(temp1);
	write32(temp);
	comm32(0x42);		//MWRITE
	//data32(bmp1, 9600);

	//while ((GetStatusLCD()&0x03)!=0x03);  
	//Send8LCD(1, 0xB0);			//set autodata mode on
	
	while(Y >= 28)//X <= 30)
		{
		
		while(bit_data <=7)
			{
			max = data[counter++];
			min = data[counter++];
			//counter++;
			
			if(max >= Y)
				{
				if(min <= Y)
					{
					if(bit_data == 7) da |= 0x01;
					if(bit_data == 6) da |= 0x02;
					if(bit_data == 5) da |= 0x04;
					if(bit_data == 4) da |= 0x08;
					if(bit_data == 3) da |= 0x10;
					if(bit_data == 2) da |= 0x20;
					if(bit_data == 1) da |= 0x40;
					if(bit_data == 0) da |= 0x80;
					}
				}
        	        	
			bit_data++;
			}
        	        	
		//da |= setka_01[Xs++];
		
		//while ((GetStatusLCD()&0x08)!=0x08);  //
		//Send8LCD(0, da);
		write32(da);

		da = 0;
		Y--;
		bit_data = 0;
		counter = counter - 16;
		}
	
	//while ((GetStatusLCD()&0x03)!=0x03);  //
	//Send8LCD(1, 0xB2);			//set autodata mode off
	
	//X=0;
	Y=228;    	
	Xs=Xs+1;
	X++;
	counter = counter + 16;
	}
*/	
while(X <= 37)//Y >= 28)
	{
	//#asm("cli")
	temp = Xs;
	temp >>= 8;
	temp1 = Xs;
	
	//comm32(0x46);		//CSRW
	DDRC=0xFF;
	PORTD.6 = 1; 		//A0=1
	PORTC = 0x46;
	//PORTD.7 = 0;		//CS=0
	//PORTD.5 = 0;		//WR=0
	//PORTD &= ~0xA0;
	PORTD &= 0x5F;
	#asm("nop")
	//#asm("nop")
	//PORTD.5 = 1;		//WR=1
	//PORTD.7 = 1;		//CS=1
	PORTD |= 0xA0;
	//DDRC=0x00;
	
	//write32(temp1);
	//DDRC=0xFF;
	PORTD.6 = 0; 		//A0=0
        PORTC = temp1;
        //PORTD.7 = 0;		//CS=0
	//PORTD.5 = 0;		//WR=0
	//PORTD &= ~0xA0;
	PORTD &= 0x5F;
	#asm("nop")
	//#asm("nop")
	//PORTD.5 = 1;		//WR=1
	//PORTD.7 = 1;		//CS=1
	PORTD |= 0xA0;
	//DDRC=0x00;
	
	//write32(temp);
	//DDRC=0xFF;
	PORTD.6 = 0; 		//A0=0
        PORTC = temp;
        //PORTD.7 = 0;		//CS=0
	//PORTD.5 = 0;		//WR=0
	//PORTD &= ~0xA0;
	PORTD &= 0x5F;
	#asm("nop")
	//#asm("nop")
	//PORTD.5 = 1;		//WR=1
	//PORTD.7 = 1;		//CS=1
	PORTD |= 0xA0;
	//DDRC=0x00;
	
	//comm32(0x42);		//MWRITE
	//DDRC=0xFF;
	PORTD.6 = 1; 		//A0=1
	PORTC = 0x42;
	//PORTD.7 = 0;		//CS=0
	//PORTD.5 = 0;		//WR=0
	//PORTD &= ~0xA0;
	PORTD &= 0x5F;
	#asm("nop")
	//#asm("nop")
	//PORTD.5 = 1;		//WR=1
	//PORTD.7 = 1;		//CS=1
	PORTD |= 0xA0;
	//DDRC=0x00;
        
	max1 = data1[counter];
	max01 = data2[counter++];
	min1 = data1[counter];
	min01 = data2[counter++];
	max2 = data1[counter];
	max02 = data2[counter++];
	min2 = data1[counter];
	min02 = data2[counter++];
	max3 = data1[counter];
	max03 = data2[counter++];
	min3 = data1[counter];
	min03 = data2[counter++];
	max4 = data1[counter];
	max04 = data2[counter++];
	min4 = data1[counter];
	min04 = data2[counter++];
	max5 = data1[counter];
	max05 = data2[counter++];
	min5 = data1[counter];
	min05 = data2[counter++];
	max6 = data1[counter];
	max06 = data2[counter++];
	min6 = data1[counter];
	min06 = data2[counter++];
	max7 = data1[counter];
	max07 = data2[counter++];
	min7 = data1[counter];
	min07 = data2[counter++];
	max8 = data1[counter];
	max08 = data2[counter++];
	min8 = data1[counter];
	min08 = data2[counter++];

	while(Y >= 29)//X <= 30)
		{
		
		//while(bit_data <=7)
		//	{
			//max = data[counter++];
			//min = data[counter++];
			
			if(max1 >= Y)
				{
				if(min1 <= Y)
					{
					da |= 0x80;
					}
				}
        	        	
			if(max2 >= Y)
				{
				if(min2 <= Y)
					{
					da |= 0x40;
					}
				}
        	        	
			if(max3 >= Y)
				{
				if(min3 <= Y)
					{
					da |= 0x20;
					}
				}
        	        	
			if(max4 >= Y)
				{
				if(min4 <= Y)
					{
					da |= 0x10;
					}
				}

			if(max5 >= Y)
				{
				if(min5 <= Y)
					{
					da |= 0x08;
					}
				}
        	        	
			if(max6 >= Y)
				{
				if(min6 <= Y)
					{
					da |= 0x04;
					}
				}
        	        	
			if(max7 >= Y)
				{
				if(min7 <= Y)
					{
					da |= 0x02;
					}
				}
        	        	
			if(max8 >= Y)
				{
				if(min8 <= Y)
					{
					da |= 0x01;
					}
				}
				
				
			if(max01 >= Y)
				{
				if(min01 <= Y)
					{
					da |= 0x80;
					}
				}
        	        	
			if(max02 >= Y)
				{
				if(min02 <= Y)
					{
					da |= 0x40;
					}
				}
        	        	
			if(max03 >= Y)
				{
				if(min03 <= Y)
					{
					da |= 0x20;
					}
				}
        	        	
			if(max04 >= Y)
				{
				if(min04 <= Y)
					{
					da |= 0x10;
					}
				}

			if(max05 >= Y)
				{
				if(min05 <= Y)
					{
					da |= 0x08;
					}
				}
        	        	
			if(max06 >= Y)
				{
				if(min06 <= Y)
					{
					da |= 0x04;
					}
				}
        	        	
			if(max07 >= Y)
				{
				if(min07 <= Y)
					{
					da |= 0x02;
					}
				}
        	        	
			if(max08 >= Y)
				{
				if(min08 <= Y)
					{
					da |= 0x01;
					}
				}
        	        	
		//	}
        	        	
		//da |= setka_01[Xs++];
		
		//while ((GetStatusLCD()&0x08)!=0x08);  //
		//Send8LCD(0, da);3
		
		//write32(da);
		
		//DDRC=0xFF;
/*		
		DDRC = 0;
		PORTD.6 = 0;            //A0=0
		PORTD.5 = 1;		//WR=1
		PORTD.7 = 0;		//CS=0
		PORTD.4 = 0;            //RD=0
        	while((PINC | 0xBF) == 0xFF);
		PORTD.4 = 1;            //RD=1
		DDRC = 0xFF;
*/		
		PORTD.6 = 0; 		//A0=0
		//da= ~da;
                PORTC = da;
                //PORTD.7 = 0;		//CS=0
		//PORTD.5 = 0;		//WR=0
		//PORTD &= ~0xA0;
		PORTD &= 0x5F;
		#asm("nop")
		//#asm("nop")
		//PORTD.5 = 1;		//WR=1
		//PORTD.7 = 1;		//CS=1
		PORTD |= 0xA0;
		//DDRC=0x00;
                //#asm("sei")
		da = 0;
		Y--;
		//bit_data = 0;
		//counter = counter - 16;
		
		}
	
	//while ((GetStatusLCD()&0x03)!=0x03);  //
	//Send8LCD(1, 0xB2);			//set autodata mode off
	
	//X=0;
	Y=228;    	
	Xs++;//=Xs+1;
	X++;
	//counter = counter + 16;
	}
print_poz_trig1();
DDRC=0x00;

}


// External Interrupt 0 service routine
/*
interrupt [EXT_INT0] void ext_int0_isr(void)
{
// Place your code here
sinhr = 1;
EIMSK=0x00;

while(adc_count < 2500)
	{
	ADCSRA|=0x40;
	// Wait for the AD conversion to complete
	while ((ADCSRA & 0x10)==0);
	adc_tab[adc_count++]=ADCH;
	ADCSRA|=0x10;
	}
}
*/

/*
void read_adc(void)
{
EIMSK=0x00;

while(adc_count < 1220)//2500)
	{
	ADCSRA|=0x40;
	// Wait for the AD conversion to complete
	while ((ADCSRA & 0x10)==0);
	adc_tab[adc_count++]=ADCH;
	ADCSRA|=0x10;
	}
}
*/

#include <key.c>
/*
interrupt [USART0_RXC] void usart0_rx_isr(void)
{
char status,data;
status=UCSR0A;//1A;
data=UDR0;//1;
if ((status & (0x10 | 0x08 | 0x04))==0)
   {
   key = data;
   keyscan1();
   data_reg_wr();
   }

}
*/
interrupt [USART1_RXC] void usart1_rx_isr(void)
{
char status,data;
status=UCSR1A;//1A;
data=UDR1;//1;
if ((status & (0x10 | 0x08 | 0x04))==0)
   {
   key = data;
   keyscan1();
   data_reg_wr();
   }

}

/*
void uart(void)
{
if((UCSR1A & 0x80)!= 0)
	{
	key = UDR1;
   	keyscan1();
   	}
 //UCSR0A=0;
 //key=255;
}
*/

// ADC interrupt service routine
//interrupt [ADC_INT] void adc_isr(void)
//{
//unsigned char adc_data;
// Read the 8 most significant bits
// of the AD conversion result
//adc_data=ADCH;
// Place your code here
//if(adc_count <= 250) 
//	{
        
	//adc_tab[adc_count++]=ADCH;//adc_data;
	                                                  
	//adc_count++;
//	}
//else ADCSRA &= ~0x40;

//}

// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
// Place your code here
/*
tmr0++;
if(tmr0 >= 220)
	{
	fill_cls();
	//count_fill = 8840;
	count_fill = 8875;
	fill();
	flag_01 = 8;//0;
	TCCR0=0;
	TCNT0=0;
	tmr0=0;
	
	}
	*/
}

// Declare your global variables here

// Declare your global variables here


void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTA=0x06;
DDRA=0xBE;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;

// Port C initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0xB4;
DDRD=0xF8;

// Port E initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTE=0x00;
DDRE=0x0C;

// Port F initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTF=0x00;
DDRF=0x00;

// Port G initialization
// Func4=In Func3=In Func2=In Func1=In Func0=In 
// State4=T State3=T State2=T State1=T State0=T 
PORTG=0x00;
PORTG=0x07;
DDRG=0x1F;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0 output: Disconnected
ASSR=0x00;
TCCR0=0x00;
TCNT0=0x00;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// OC1C output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;
OCR1CH=0x00;
OCR1CL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// Timer/Counter 3 initialization
// Clock source: System Clock
// Clock value: Timer 3 Stopped
// Mode: Normal top=FFFFh
// Noise Canceler: Off
// Input Capture on Falling Edge
// OC3A output: Discon.
// OC3B output: Discon.
// OC3C output: Discon.
TCCR3A=0x00;
TCCR3B=0x00;
TCNT3H=0x00;
TCNT3L=0x00;
ICR3H=0x00;
ICR3L=0x00;
OCR3AH=0x00;
OCR3AL=0x00;
OCR3BH=0x00;
OCR3BL=0x00;
OCR3CH=0x00;
OCR3CL=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
// INT3: Off
// INT4: Off
// INT5: Off
// INT6: Off
// INT7: Off
EICRA=0x03;
EICRB=0x00;
EIMSK=0x00;
EIFR=0x01;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x01;
ETIMSK=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
// Analog Comparator Output: Off
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC Clock frequency: 109,375 kHz
// ADC Voltage Reference: AREF pin
// ADC High Speed Mode: On
// Only the 8 most significant bits of
// the AD conversion result are used
/*
ADMUX=ADC_VREF_TYPE;
ADCSRA=0xFE;//F8//FA
SFIOR&=0xEF;
SFIOR|=0x10;
*/

/*
ADMUX=ADC_VREF_TYPE;
ADCSRA=0x84;
SFIOR&=0xEF;
SFIOR|=0x10;
*/

// USART0 initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART0 Receiver: On
// USART0 Transmitter: Off
// USART0 Mode: Asynchronous
// USART0 Baud rate: 5000 
/*
UCSR0A=0x00;
UCSR0B=0x90;
UCSR0C=0x06;
UBRR0H=0x00;
UBRR0L=0x9B;
*/
UCSR0B=0x00;

UCSR1A=0x00;
UCSR1B=0x90;
//UCSR1B=0x10;
UCSR1C=0x06;
UBRR1H=0x00;
UBRR1L=0xF8;//E5;//9B;//C7;//18//F9//13


// Global enable interrupts
//#asm("sei")
select_divt=14;
select_scroll_time=7;

dac_ch1 = 162;
dac_ch2 = 158;
dac_sinh = 158;

data_dac_wr(0, 0);
data_dac_wr(1, dac_sinh);
data_dac_wr(2, dac_ch1);
data_dac_wr(3, dac_ch2);
//print_poz_ch();

data_reg = 0xE0000000; 


mode1 = 0;
mode2 = 0;
mode3 = 0;
mode4 = 0;
mode5 = 0;
//char mode6 = 0;
//char mode7 = 0;
mode8 = 0;

select_div1=10;
select_div2=10;
select_divt=14;

//adc_count = 0;
//while(adc_count < 1220)
//	{
//	adc_tab[adc_count++]=0;//120;
//	}

data_reg_wr();

///*
lcd_init();

comm32(0x4C);		//CSRDIR_rait
comm32(0x46);		//CSRW
write32(0x80);
write32(0x25);
comm32(0x42);		//MWRITE
data32(bmp0, 9600);

comm32(0x4C);		//CSRDIR_rait
comm32(0x46);		//CSRW
write32(0x00);
write32(0x4B);
comm32(0x42);		//MWRITE
data32(bmp1, 9600);

/*
comm32(0x4F);		//CSRDIR_doun
comm32(0x46);		//CSRW
write32(0x90);//50);
write32(0x10);//05);
comm32(0x42);		//MWRITE
data32(bmp_m1, 7);
comm32(0x46);		//CSRW
write32(0xF0);
write32(0x14);
comm32(0x42);		//MWRITE
data32(bmp_m2, 7);
*/
print_poz_ch();
print_poz_trig();
/*
comm32(0x46);		//CSRW
write32(0x8F);
write32(0x10);
comm32(0x42);		//MWRITE
data32(bmp_mt1, 7);
*/
//delay_ms(3000);
//comm32(0x46);		//CSRW
//write32(0xB0);
//write32(0x2E);
//comm32(0x42);		//MWRITE
//data32(bmp_mt, 17);
//*/

flag_01 = 8;

if(mode1 == 0)print_mode(1, _post);
if(mode1 == 1)print_mode(1, _per);
if(mode1 == 2)print_mode(1, _gnd);
if(mode1 == 3)print_mode(1, _off);

if(mode2 == 0)print_mode(2, _post);
if(mode2 == 1)print_mode(2, _per);
if(mode2 == 2)print_mode(2, _gnd);
if(mode2 == 3)print_mode(2, _off);

if(mode5 == 0)print_mode(5, _post);
if(mode5 == 1)print_mode(5, _per);

if(ring == 0)print_mode(0, _s_on);
if(ring == 1)print_mode(0, _s_off);

if(stop == 0)print_stop(_run);
if(stop == 1)print_stop(_stop);

if(select_div1 == 1)print_div(1, _010, _mv);
if(select_div1 == 2)print_div(1, _020, _mv);
if(select_div1 == 3)print_div(1, _050, _mv);
if(select_div1 == 4)print_div(1, _100, _mv);
if(select_div1 == 5)print_div(1, _200, _mv);
if(select_div1 == 6)print_div(1, _500, _mv);
if(select_div1 == 7)print_div(1, _001, _v);
if(select_div1 == 8)print_div(1, _002, _v);
if(select_div1 == 9)print_div(1, _005, _v);
if(select_div1 == 10)print_div(1, _010, _v);

if(select_div2 == 1)print_div(2, _005, _mv);
if(select_div2 == 2)print_div(2, _010, _mv);
if(select_div2 == 3)print_div(2, _020, _mv);
if(select_div2 == 4)print_div(2, _050, _mv);
if(select_div2 == 5)print_div(2, _100, _mv);
if(select_div2 == 6)print_div(2, _200, _mv);
if(select_div2 == 7)print_div(2, _500, _v);
if(select_div2 == 8)print_div(2, _001, _v);
if(select_div2 == 9)print_div(2, _002, _v);
if(select_div2 == 10)print_div(2, _005, _v);

if(select_divt == 1)print_div(4, _001, _us);
if(select_divt == 2)print_div(4, _002, _us);
if(select_divt == 3)print_div(4, _005, _us);
if(select_divt == 4)print_div(4, _010, _us);
if(select_divt == 5)print_div(4, _020, _us);
if(select_divt == 6)print_div(4, _050, _us);
if(select_divt == 7)print_div(4, _100, _us);
if(select_divt == 8)print_div(4, _200, _us);
if(select_divt == 9)print_div(4, _500, _us);
if(select_divt == 10)print_div(4, _001, _ms);
if(select_divt == 11)print_div(4, _002, _ms);
if(select_divt == 12)print_div(4, _005, _ms);
if(select_divt == 13)print_div(4, _010, _ms);
if(select_divt == 14)print_div(4, _020, _ms);
if(select_divt == 16)print_div(4, _050, _ms);
if(select_divt == 17)print_div(4, _100, _ms);
if(select_divt == 18)print_div(4, _200, _ms);
if(select_divt == 19)print_div(4, _500, _ms);
if(select_divt == 20)print_div(4, _001, _s);

if(select_trig == 1)print_div(5, _ch1, _rise);
if(select_trig == 2)print_div(5, _ch1, _fall);
if(select_trig == 3)print_div(5, _ch2, _rise);
if(select_trig == 4)print_div(5, _ch2, _fall);
if(select_trig == 5)print_div(5, _ext, _rise);
if(select_trig == 6)print_div(5, _ext, _fall);

if(select_edge == 1)print_div(6, _auto, _zero2);
if(select_edge == 2)print_div(6, _norm, _zero2);
if(select_edge == 3)print_div(6, _single, _zero2);

if(mode8 == 0)print_div(8, _ch1, _zero2);
if(mode8 == 1)print_div(8, _ch2, _zero2);
if(mode8 == 2)print_div(8, _time, _zero2);
if(mode8 == 3)print_div(8, _trig, _zero2);

print_scroll_time(select_scroll_time, _scroll);

count_fill = 8875;
fill();
flag_01 = 8;//0;

while (1)
	{
	
	
	
	// Place your code here
	
	#asm("wdr")
	if(select_edge == 1)
		{
		#asm("sei")
	
		if(stop == 0)
			{
			if(select_trig == 1)EICRA = 3;
			if(select_trig == 2)EICRA = 2;
			if(select_trig == 3)EICRA = 3;
			if(select_trig == 4)EICRA = 2;
			if(select_trig == 5)EICRA = 3;
			if(select_trig == 6)EICRA = 2;
			EIFR|=0x01;
			EIMSK|=0x01;
	        	//while(sinhr == 0);
		        delay_ms(50);
		        
        		//read_adc();
        		
	        	EIMSK=0x00;
	        
			//ADCSRA |= 0x40;
			//while(adc_count < 250)ADCSRA |= 0x40;
		
			//ADCSRA &= ~0x40;
			adc_count = 0;
			sinhr = 0;
		
			//delay_ms(100);
			}
		else delay_ms(100);
		}
	if(select_edge == 2)
		{
		#asm("sei")
	
		if(stop == 0)
			{
			if(select_trig == 1)EICRA = 3;
			if(select_trig == 2)EICRA = 2;
			if(select_trig == 3)EICRA = 3;
			if(select_trig == 4)EICRA = 2;
			if(select_trig == 5)EICRA = 3;
			if(select_trig == 6)EICRA = 2;
			EIFR|=0x01;
			EIMSK|=0x01;
	        	//while(sinhr == 0);
		        delay_ms(50);
        		//read_adc();
	        	EIMSK=0x00;
	        
			//ADCSRA |= 0x40;
			//while(adc_count < 250)ADCSRA |= 0x40;
		
			//ADCSRA &= ~0x40;
			adc_count = 0;
			sinhr = 0;
		
			//delay_ms(100);
			}
		else delay_ms(100);
		}
	if(select_edge == 3)
		{
		#asm("sei")
	
		if(stop == 0)
			{
			if(select_trig == 1)EICRA = 3;
			if(select_trig == 2)EICRA = 2;
			if(select_trig == 3)EICRA = 3;
			if(select_trig == 4)EICRA = 2;
			if(select_trig == 5)EICRA = 3;
			if(select_trig == 6)EICRA = 2;
			EIFR|=0x01;
			EIMSK|=0x01;
	        	//while(sinhr == 0);
		        delay_ms(50);
        		//read_adc();
	        	EIMSK=0x00;
	        	if(sinhr == 1)
	        		{
		        	stop = 1;
		        	print_stop(_stop);
	        		}
			//ADCSRA |= 0x40;
			//while(adc_count < 250)ADCSRA |= 0x40;
		
			//ADCSRA &= ~0x40;
			adc_count = 0;
			sinhr = 0;
		
			//delay_ms(100);
			}
		else delay_ms(100);
		}
	
	
	//delay_ms(250);
	#asm("sei")
	//keyscan1();
	//data_reg |= 0x00020000;
	data_reg_wr();
	PORTG |= 0x03;
	PORTA.7 = 0;
	
	data_reg &= ~0x00000004;/////////////
	data_reg_wr();
        data_reg |= 0x00000008;
	data_reg_wr();
	
	PORTE &= ~0x0C;
	//delay_us(10);
	PORTE |= 0x0C;
	if(select_divt <= 11)time = 100;
	if(select_divt == 12)time = 200;
	if(select_divt == 13)time = 400;
	if(select_divt == 14)time = 800;
	while(PINA.0 != 1)
	        {
	        delay_ms(1);
	        if(time != 0)time--;
	        else
	                {
        	        if((data_reg & 0x00000001)== 0)
        	                {
        	                data_reg |= 0x00000001;
        	                data_reg_wr();
	                        data_reg &= ~0x00000001;
        	                data_reg_wr();
        	                }
        	        else
        	                {
        	                data_reg &= ~0x00000001;
        	                data_reg_wr();
        	                data_reg |= 0x00000001;
        	                data_reg_wr();
        	                }
        	        }
	        }
	
	data_reg &= ~0x00000008;
	data_reg_wr();
	data_reg |= 0x00000004;
	data_reg_wr();
	PORTA.7 = 1;
	//PORTG &= ~0x02;
	PORTE &= ~0x08;
	//delay_us(10);
	PORTE |= 0x08;
	#asm("cli")
	print_signal();
	//data_reg_wr();
	//keyscan1();
	//uart();
	#asm("sei")
	
	}
} 

void print_poz_ch(void)
{
unsigned int a;
unsigned int b;
unsigned char c;
unsigned char count=0;

a = dac_ch1 - 132;
b = a/2;
a = b * 200;
b = 7240 - a;
//a = 240;
c = b;
//b >>= 8;

comm32(0x4F);		//CSRDIR_doun
comm32(0x46);		//CSRW
write32(0x00);
write32(0x00);
comm32(0x42);		//MWRITE
while(count < 206)
	{
	write32(0x00);
//	delay_ms(5);
	count++;
	}
	
comm32(0x46);		//CSRW
write32(c);//50);
b >>= 8;
c = b;
write32(c);//05);
comm32(0x42);		//MWRITE
data32(bmp_m1, 7);

a = dac_ch2 - 128;
b = a/2;
a = b * 200;
b = 7240 - a;
//a = 240;
c = b;
//b >>= 8;

comm32(0x4F);		//CSRDIR_doun
comm32(0x46);		//CSRW
write32(c);//50);
b >>= 8;
c = b;
write32(c);//05);
comm32(0x42);		//MWRITE
data32(bmp_m2, 7);
} 

void print_poz_trig(void)
{
unsigned int a;
unsigned int b;
unsigned char c;
unsigned char count=0;

a = dac_sinh - 128;
b = a/2;
a = b * 200;
b = 7279 - a;
//a = 240;
c = b;
//b >>= 8;

comm32(0x4F);		//CSRDIR_doun
comm32(0x46);		//CSRW
write32(0x8F);
write32(0x01);
comm32(0x42);		//MWRITE
while(count < 200)
	{
	write32(0x00);
//	delay_ms(5);
	count++;
	}
	
comm32(0x46);		//CSRW
write32(c);//50);
b >>= 8;
c = b;
write32(c);//05);
comm32(0x42);		//MWRITE
data32(bmp_mt1, 7);
/*
a = dac_ch2 - 128;
comm32(0x46);		//CSRW
write32(0x8F);
write32(0x10);
comm32(0x42);		//MWRITE
data32(bmp_mt1, 7);
*/
}

void print_poz_trig1(void)
{
char a=0;
char b;
comm32(0x46);		//CSRW
//write32(400+select_scroll_time);
//write32(0x01);
//comm32(0x42);		//MWRITE
//data32(bmp_mt2, 5);

switch(select_scroll_time)
        {
        case 13:
                write32(401);
                write32(0x01);
                comm32(0x42);		//MWRITE
                while(a != 5)
                	{
        	b = bmp_mt2[a++];
        	b <<= 5;
        	write32(b);
	                }
	        break;
        case 12:
                write32(403);
                write32(0x01);
                comm32(0x42);		//MWRITE
                while(a != 5)
                	{
        	b = bmp_mt2[a++];
        	b >>= 3;
        	write32(b);
	                }
	        comm32(0x46);		//CSRW
	        write32(404);
                write32(0x01);
                comm32(0x42);		//MWRITE
                a = 0;
                while(a != 5)
                	{
        	b = bmp_mt2[a++];
        	b <<= 5;
        	write32(b);
	                }
	        break;
        case 11:
                write32(406);
                write32(0x01);
                comm32(0x42);		//MWRITE
                while(a != 5)
                	{
        	b = bmp_mt2[a++];
        	b >>= 4;
        	write32(b);
	                }
	        comm32(0x46);		//CSRW
	        write32(407);
                write32(0x01);
                comm32(0x42);		//MWRITE
                a = 0;
                while(a != 5)
                	{
        	b = bmp_mt2[a++];
        	b <<= 4;
        	write32(b);
	                }
	        break;
        case 10:
                write32(409);
                write32(0x01);
                comm32(0x42);		//MWRITE
                while(a != 5)
                	{
        	b = bmp_mt2[a++];
        	b >>= 5;
        	write32(b);
	                }
	        comm32(0x46);		//CSRW
	        write32(410);
                write32(0x01);
                comm32(0x42);		//MWRITE
                a = 0;
                while(a != 5)
                	{
        	b = bmp_mt2[a++];
        	b <<= 3;
        	write32(b);
	                }
	        break;
        case 9:
                write32(412);
                write32(0x01);
                comm32(0x42);		//MWRITE
                while(a != 5)
                	{
        	b = bmp_mt2[a++];
        	b >>= 6;
        	write32(b);
	                }
	        comm32(0x46);		//CSRW
	        write32(413);
                write32(0x01);
                comm32(0x42);		//MWRITE
                a = 0;
                while(a != 5)
                	{
        	b = bmp_mt2[a++];
        	b <<= 2;
        	write32(b);
	                }
	        break;
        case 8:
                write32(415);
                write32(0x01);
                comm32(0x42);		//MWRITE
                while(a != 5)
                	{
        	b = bmp_mt2[a++];
        	b >>= 7;
        	write32(b);
	                }
	        comm32(0x46);		//CSRW
	        write32(416);
                write32(0x01);
                comm32(0x42);		//MWRITE
                a = 0;
                while(a != 5)
                	{
        	b = bmp_mt2[a++];
        	b <<= 1;
        	write32(b);
	                }
	        break;
        case 7:
                write32(419);
                write32(0x01);
                comm32(0x42);		//MWRITE
                while(a != 5)
                	{
        	b = bmp_mt2[a++];
        	//b >>= 4;
        	write32(b);
	                }
	        //comm32(0x46);		//CSRW
	        //write32(419);
                //write32(0x01);
                //comm32(0x42);		//MWRITE
                //a = 0;
                //while(a != 5)
                	{
        	//b = bmp_mt2[a++];
        	//b <<= 4;
        	//write32(b);
	                }
	        break;
        case 6:
                write32(422);
                write32(0x01);
                comm32(0x42);		//MWRITE
                while(a != 5)
                	{
        	b = bmp_mt2[a++];
        	b >>= 1;
        	write32(b);
	                }
	        comm32(0x46);		//CSRW
	        write32(423);
                write32(0x01);
                comm32(0x42);		//MWRITE
                a = 0;
                while(a != 5)
                	{
        	b = bmp_mt2[a++];
        	b <<= 7;
        	write32(b);
	                }
	        break;
        case 5:
                write32(425);
                write32(0x01);
                comm32(0x42);		//MWRITE
                while(a != 5)
                	{
        	b = bmp_mt2[a++];
        	b >>= 2;
        	write32(b);
	                }
	        comm32(0x46);		//CSRW
	        write32(426);
                write32(0x01);
                comm32(0x42);		//MWRITE
                a = 0;
                while(a != 5)
                	{
        	b = bmp_mt2[a++];
        	b <<= 6;
        	write32(b);
	                }
	        break;
        case 4:
                write32(428);
                write32(0x01);
                comm32(0x42);		//MWRITE
                while(a != 5)
                	{
        	b = bmp_mt2[a++];
        	b >>= 3;
        	write32(b);
	                }
	        comm32(0x46);		//CSRW
	        write32(429);
                write32(0x01);
                comm32(0x42);		//MWRITE
                a = 0;
                while(a != 5)
                	{
        	b = bmp_mt2[a++];
        	b <<= 5;
        	write32(b);
	                }
	        break;
        case 3:
                write32(431);
                write32(0x01);
                comm32(0x42);		//MWRITE
                while(a != 5)
                	{
        	b = bmp_mt2[a++];
        	b >>= 4;
        	write32(b);
	                }
	        comm32(0x46);		//CSRW
	        write32(432);
                write32(0x01);
                comm32(0x42);		//MWRITE
                a = 0;
                while(a != 5)
                	{
        	b = bmp_mt2[a++];
        	b <<= 4;
        	write32(b);
	                }
	        break;
        case 2:
                write32(434);
                write32(0x01);
                comm32(0x42);		//MWRITE
                while(a != 5)
                	{
        	b = bmp_mt2[a++];
        	b >>= 5;
        	write32(b);
	                }
	        comm32(0x46);		//CSRW
	        write32(435);
                write32(0x01);
                comm32(0x42);		//MWRITE
                a = 0;
                while(a != 5)
                	{
        	b = bmp_mt2[a++];
        	b <<= 3;
        	write32(b);
	                }
	        break;
        case 1:
                write32(437);
                write32(0x01);
                comm32(0x42);		//MWRITE
                while(a != 5)
                	{
        	b = bmp_mt2[a++];
        	b >>= 6;
        	write32(b);
	                }
	        comm32(0x46);		//CSRW
	        write32(438);
                write32(0x01);
                comm32(0x42);		//MWRITE
                a = 0;
                while(a != 5)
                	{
        	b = bmp_mt2[a++];
        	b <<= 2;
        	write32(b);
	                }
	        break;
        }
}

