
/*
interrupt [USART0_RXC] void usart0_rx_isr(void)
{
char status,data;
status=UCSR0A;//1A;
data=UDR0;//1;
if ((status & (0x10 | 0x08 | 0x04))==0)
   {
   key = data;
   keyscan1();
   data_reg_wr();
   }

}
*/

//interrupt [USART1_RXC] void usart1_rx_isr(void)
#pragma vector = USART1_RXC_vect 
__interrupt void USART1_RXC(void) 
{
char status,data;
status=UCSR1A;//1A;
data=UDR1;//1;
if ((status & (0x10 | 0x08 | 0x04))==0)
   {
   key = data;
   keyscan1();
   data_reg_wr();
   data_dac_wr(3, dac_ch1);
   data_dac_wr(2, dac_ch2);
   data_dac_wr(5, contrast);
   data_dac_wr(4, bright<<1);//+60);
   print_poz_ch();
   }

}

/*
void uart(void)
{
if((UCSR1A & 0x80)!= 0)
	{
	key = UDR1;
   	keyscan1();
   	}
 //UCSR0A=0;
 //key=255;
}
*/


#pragma vector = TIMER0_OVF_vect 
__interrupt void TMR0_ovf(void) 
{ 
if(display != 0)
	{
	count_menu++;
	if(count_menu == 100)
		{
		count_menu=0;
		display=0;
		LCD_PUTSF(1, 13, 100, "                 ",0);
		}
	}
}
