
/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.1 Professional
Automatic Program Generator
 Copyright 1998-2006 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 25.07.2008
Author  : F4CG                            
Company : F4CG                            
Comments: 


Chip type           : ATmega128
Program type        : Application
Clock frequency     : 20,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 1024
*****************************************************/
//#include <ioavr.h>
#include <iom128.h>
//#include <delay.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <intrinsics.h>

#include "init_cpu.c"

#include "font.c"

#include "variable.c"
#include "bmp.c"

#include "dac_reg.c"
#include "massiv.c"
#include "sed1335f.c"
#include "print.c"
#include "print_sig.c"
//#include "key.c"
#include "zero.c"
#include "keyscan.c"
#include "interrupt.c"
#include "InitVar.c"
#include "startprint.c"






void main(void)
	{
	// Declare your local variables here
	
	init_cpu();
	
	lcd_init_1p();
	
	load_Evar();
	
	start_print();
	
	//fill();
	
	//comm32(0x4F);		//CSRDIR (0x4C-, 0x4D-, 0x4E-, 0x4F-)
	//comm32(0x46);		//CSRW  
	//write32(0x80);          //
	//write32(0x25);          //
	//comm32(0x42);		//MWRITE   
	LCD_PUTSF(0, 0, 0, "DO-25",1);
	
	temp = - 1532;
	temp1 = 0 - temp;
	sprintf(data3,"1Up=%+i,%uV",temp/100,temp1%100);
	//LCD_PUTSF(2, 2, 192, "1Up=");
	LCD_PUTS(2, 2, 192, data3,0);
	//LCD_PUTS(0, 2, 192, data3,0);
	temp = 0;
	LCD_PUTSF(2, 2, 200, "1Un=34,2V",0);
	LCD_PUTSF(2, 26, 192, "2Up=24,6mV",0);
	LCD_PUTSF(2, 26, 200, "2Un=458mV",0);
	//LCD_PUTSF(0, 2, 200, "1Un=34,2V",0);
	//LCD_PUTSF(0, 26, 192, "2Up=24,6mV",0);
	//LCD_PUTSF(0, 26, 200, "2Un=458mV",0);
	//LCD_PUTS(0, 0, 211, data3);
	
	RAM_R_S_0;            
	
	OE_ADC_1;
	PORTA &= ~0x08;
	SEL_CLK_RAM_0;        
	PORTB |= 0x50;
	__delay_cycles(2000);   //100us
	PORTB &= ~0x50;         //????? 2-? ?????????
	
	asm("sei");
	
	
	while (1)
		{
		RAM_R_S_0;            //?????????? ??????
		//OE_ADC = 0;
		//PORTA.4 = 0;
		//PORTA.3 = 0;
		OE_ADC_0;
		SEL_CLK_RAM_0;        //???????????? ?? ??????????
		
		//RESET_COUNT_RAM_1;
		//RESET_COUNT_TRIG_1;
		PORTB |= 0x50;          //????? 2-? ?????????
		//RESET_COUNT_RAM_0;
		//RESET_COUNT_TRIG_0;
		PORTB &= ~0x50;         //????? 2-? ?????????
		
		if(select_divt <= 13)time = 200;
		if(select_divt == 14)time = 500;
		if(select_divt == 15)time = 1000;
		if(select_divt == 16)time = 2000;
		
		//while(PINA.2 == 0)      //???? ?????? ?? ?????????
		while(time != 0)
			{
			__delay_cycles(20000);   //1000us
			if((PINA & 0x04) == 0)time--;
			else    time=0;
			}
		
		//delay_us(100);
		//while(PINA.2 == 0)      //???? ?????? ?? ?????????
		
		OE_ADC_1;
		
		RAM_R_S_1;
		//PORTA.4 = 1;
		//PORTA.3 = 1;
		SEL_CLK_RAM_1;        //???????????? ?? CPU
		RAM_R_S_1;            //?????????? ??????
		RESET_COUNT_TRIG_1;   //????? ???????? ????????
		__delay_cycles(20);   //1us
		RESET_COUNT_TRIG_0;   //????? ???????? ????????
		
		//PORTB |= 0x50;          //????? 2-? ?????????
		//delay_us(100);
		//PORTB &= ~0x50;         //????? 2-? ?????????
		
		//asm("cli");
		massiv();
		asm("cli");
		print_signal();
		//data_reg_wr();
		//keyscan1();
		//uart();
		//data_reg_wr();
		//print_poz_trig();
		max_ch1 = max_ch1 - poz_1;//
		min_ch1 = min_ch1 - poz_1;//
		max_ch1 = max_ch1 * 2;
		min_ch1 = min_ch1 * 2;
		LCD_PUTSF(2, 2, 192, "               ",0);
		LCD_PUTSF(2, 2, 200, "               ",0);
		sprintf(data3,"1Up=%+i,%uV",max_ch1/10,max_ch1%10);
		LCD_PUTS(2, 2, 192, data3,0);
		if(min_ch1 < 0)temp1 = 0 - min_ch1;
		else	temp1 = min_ch1;
		sprintf(data3,"1Un=%+i,%uV",min_ch1/10,temp1%10);
		LCD_PUTS(2, 2, 200, data3,0);
		
		max_ch2 = max_ch2 - poz_2;//
		min_ch2 = min_ch2 - poz_2;//
		max_ch2 = max_ch2 * 2;
		min_ch2 = min_ch2 * 2;
		LCD_PUTSF(2, 26, 192, "               ",0);
		LCD_PUTSF(2, 26, 200, "               ",0);
		sprintf(data3,"2Up=%+i,%uV",max_ch2/10,max_ch2%10);
		LCD_PUTS(2, 26, 192, data3,0);
		if(min_ch2 < 0)temp1 = 0 - min_ch2;
		else	temp1 = min_ch2;
		sprintf(data3,"2Un=%+i,%uV",min_ch2/10,temp1%10);
		LCD_PUTS(2, 26, 200, data3,0);
		///////////////////////////////////////////////
		LCD_PUTSF(2, 2, 30, "               ",0);
		sprintf(data3,"start=%+i",start);
		LCD_PUTS(2, 2, 30, data3,0);
		///////////////////////////////////////////////
		asm("sei");
		}
	} 



