
void init_cpu(void)
{

// Port B initialization

PORTB=0x00;
DDRB=0x00;

// Port C initialization

PORTC=0x00;
DDRC=0x00;

// Port D initialization

PORTD=0x00;
DDRD=0x82;



// Timer/Counter 0 initialization

TCCR0=0x00;
TCNT0=0xB9;
TCCR0=0x05;


//ADC initialize
// Conversion time: 112uS

 ADCSR = 0x00; //disable adc
 ADMUX = 0xC7; //select adc input 7
 //ACSR  = 0x80;
 ADCSR = 0xDD;

 
 
// Timer/Counter 1 initialization

TCCR1B = 0x00; //stop
TCNT1H = 0xC7; //setup
TCNT1L = 0xC1;
OCR1AH = 0x38;
OCR1AL = 0x3F;
OCR1BH = 0x38;
OCR1BL = 0x3F;
ICR1H  = 0x38;
ICR1L  = 0x3F;
TCCR1A = 0x00;
TCCR1B = 0x05; //start Timer

// Timer/Counter 2 initialization

TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;


// External Interrupt(s) initialization


// Timer(s)/Counter(s) Interrupt(s) initialization


// USART initialization
//5000   14.7456MHz 

UCSRB = 0x00; //disable while setting baud rate
UCSRA = 0x00;
UCSRC = 0x06;
UBRRL = 0xB7;//07; //set baud rate 115200
UBRRH = 0x00; //set baud rate hi
UCSRB = 0x08;

//9600  8MHz
//UCSRA=0x00;
//UCSRB=0x08;
//UCSRC=0x86;
//UBRRH=0x00;
//UBRRL=0x33;
}