
// cristall = 14.7456 MHz
//#include <ioavr.h>
#include <iom8.h>
//#include <delay.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <intrinsics.h>

#include "init_cpu.c"

#include "variable.c"
//#include "delay_.c"





void delay_us(unsigned int del)
{
 unsigned char a = 2;
 while(del != 0)
 		   {
 		   while(a != 0)
 		   		   {
				   a--;
				   }
 		   del--;
 		   a = 2;
 		   }
}

#include "keyscan.c"
#include "interrupt.c"

int main()
{
 asm("cli"); //disable all interrupts
 init_cpu();

 flag_adc = 0;
 
 MCUCR = 0xA0;
 GIFR = 0x80;
 GICR  = 0x80;
 TIMSK |= 0x04; //timer1 interrupt sources
 TIMSK |= 0x01; //timer0 interrupt sources
 asm("sei"); //re-enable interrupts

 off = 0;
 power = 1;
 while(1)
 		 {
		 asm("wdr");
		 keyscan();
		 //delay_us(1000);
		 
		 DDRB &= ~0x0F;
		 DDRD &= ~0x08;
		 DDRB |= 0x08;
		 PORTB &= ~0x08;
		 PORTD |= 0x08;
		 
		 if(count_off >= 10)
				{
				count_off = 50;
				power=1;
				off = 100;
				while((UCSRA & 0x20)== 0)
					{
					}
				UDR = 0x10;
				delay_us(65000);
				PORTD &= ~0x80;
				}
		 
		 switch (power)
         		{
				case 0:
				//if(key == 0x10)
				if((PIND & 0x08) == 0)
                		  {
						  off++;
                		  if(off >= 20)
						  		 {
								 power=1;
								 off = 100;
								 PORTD &= ~0x80;
								 }
                		  }
				else	  
						{
						off = 0;
						}
       			break;
        		case 1:
            	if((PIND & 0x08) != 0)
                		  {
						  off = 0;
                		  GIFR=0x80;
                		  GICR|=0x80;
						  //PORTD &= ~0x80;
						  MCUCR |= 0xA0;
						  UCSRB = 0x00;
						  DDRB &= ~0x0F;
						  DDRD &= ~0x0A;//8;
						  DDRB |= 0x08;
						  PORTB &= ~0x08;
						  PORTD |= 0x08;
						  asm("sleep"); 
                		  //sleep_enable();
                		  //powerdown();
                		  }
//				if(count_off >= 5)
//						  {
//						  off = 0;
//                		  GIFR=0x80;
//                		  GICR|=0x80;
//						  PORTD &= ~0x80;
//						  MCUCR |= 0xA0;
//						  UCSRB = 0x00;
//						  DDRB &= ~0x0F;
//						  DDRD &= ~0x0A;//8;
//						  DDRB |= 0x08;
//						  PORTB &= ~0x08;
//						  PORTD |= 0x08;
//						  asm("sleep"); 
//						  }
        		break;
        		case 2:
             	if((PIND & 0x08) == 0)
                		  {
						  off++;
                		  if(off >= 10)
						  		 {
								 //power=1;
								 //off = 100;
								 PORTD |= 0x80;
								 DDRD |= 0x02;
								 UCSRB = 0x08;
								 //count_off = 0;
								 //delay_us(10000);
								 if(off < 100)
									 {
									 delay_us(65000);
									 delay_us(65000);
									 delay_us(65000);
									 delay_us(65000);
									 UDR = 0x0A;
									 delay_us(65000);
									 delay_us(65000);
									 delay_us(65000);
									 delay_us(65000);
									 UDR = 0x0A;
									 delay_us(65000);
									 delay_us(65000);
									 delay_us(65000);
									 delay_us(65000);
									 UDR = 0x0A;
									 }
								 off = 100;
								 }
                		  }
				else
						  {
						  if(off >= 20)
						  		 {
								 off = 0;
								 power = 0;
								 }
						  else	 
							  {
							  power = 1;
							  }
						  }
        		}
		
		 }
  //return 0;
}
